#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++){
        int n;
        cin >> n;
        int a[n][3];
        for (int i = 0 ;i < n; i++){
            for (int j = 0; j < 3; j++)
                cin >> a[i][j];
        }
        long long ans = 0;
        map <int, int> m;

        for (int i = 0; i <n; i++){
            for (int j = 0; j < 2; j++){
                m[a[i][j]] += a[i][2];
            }
        }
        for (int i = 0 ; i < n; i++){
                for (int j = 0; j < 2; j++){
                    if (m[a[i][j]] > ans){
                        ans = m[a[i][j]];
                    }
                }
        }

        for (int i = 0; i < n; i++){
            long long temp1 = 0, temp2 = 0;
            for (int j= 0; j< n; j++){

                if(a[i][0] == a[j][0] || a[i][0] == a[j][1]){
                    temp1 +=a[j][2];
                }
            }
            for (int j = 0; j < n; j++){
                if(a[i][1] == a[j][0] || a[i][1] == a[j][1]){
                    temp2 +=a[j][2];
                }
            }
            //cout << temp1 << "  " << temp2 << endl;
            if (max(temp1, temp2) > ans){
                ans = max(temp1,temp2);
            }
        }
        cout << ans << endl;


    }
}
